//=========================================
// ϊs
//=========================================
float4x4 mWorld; // [hs
float4x4 mView; // r[s (Js)
float4x4 mProj; // ˉes (ˉe(2D)ϊs)

//=========================================
// Cg֌W
//=========================================
float3 lightDir;
float4 lightColor;
float4 lightSpecular;
float4 lightAmbient;

//=========================================
// }eA֌W
//=========================================
float4 mateDiffuseCol;
float4 mateSpecularCol;
float mateSpecularPow;

// JW
float3 camPos;

//=========================================
// eNX`pTv
//=========================================
texture diffuseTex;
sampler textureSampler = sampler_state
{
	Texture = <diffuseTex>;

	MinFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;

	AddressU = Wrap;
	AddressV = Wrap;
};

//=========================================
// }bsOpTv
//=========================================
float refPower = 1.0f;	// f荞ݗ	// ƂȂ0AȂ ˂݂ɂ
texture cubeTex;
samplerCUBE cubeSampler = sampler_state
{
	Texture = <cubeTex>;

	MinFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;

	AddressU = Wrap;
	AddressV = Wrap;
};

struct VS_OUT
{
	float4 projPos:POSITION;		// ˉe(2D)W
	float3 worldNormal:TEXCOORD0;	// [h@
	float2 meshUV:TEXCOORD1;		// UVW
	float3 cameraVec:TEXCOORD2;				// J璸_ւ̕
};

struct PS_OUT
{
	float4 color:COLOR0;			// o͂F
};

VS_OUT VS(float4 _pos:POSITION,float3 _normal:NORMAL, float2 _meshUV:TEXCOORD0)
{
	VS_OUT vertexOut;
	vertexOut.projPos = mul(_pos, mWorld);
	vertexOut.cameraVec = normalize(camPos - vertexOut.projPos.xyz);
	vertexOut.projPos = mul(vertexOut.projPos, mView);
	vertexOut.projPos = mul(vertexOut.projPos, mProj);

	vertexOut.worldNormal = mul(_normal, (float3x3)mWorld);
	vertexOut.worldNormal = normalize(vertexOut.worldNormal);

	vertexOut.meshUV = _meshUV;

	return vertexOut;
}

PS_OUT PS(VS_OUT _in)
{
	// f̒_̐F擾
	float4 texCol = tex2D(textureSampler, _in.meshUV);
	float4 modelCol = mateDiffuseCol * texCol;

	// }bsO
	float3 vRefDir = reflect(-_in.cameraVec, _in.worldNormal);
	float4 envCol = texCUBE(cubeSampler, vRefDir);

	// fɔ˂ʂ
	float refSpeCol = mateSpecularPow * 0.01f * refPower;
	modelCol.rgb = lerp(modelCol.rgb, envCol.rgb, refSpeCol);

	// CgZ
	float4 sumLightCol = float4(0.0f,0.0f,0.0f,1.0f);
	// 
	sumLightCol.rgb += lightAmbient.rgb;
	
	// ˌ
	//Cg[h@Ɣ˂B@ƐɂȂA͋Ȃ
	float3 refLightDir = reflect(lightDir, _in.worldNormal);
	float refSpecularPow = dot(_in.cameraVec, refLightDir);
	refSpecularPow = saturate(refSpecularPow);
	// }eA̔˂̋ۂ̔˂̋ŗݏ悷邱ƂŁA˂̍茰ɂȂ
	refSpecularPow = pow(refSpecularPow, mateSpecularPow);
	// Cgg̔ˌƌvZœ˂̋Ŕˌ
	float4 sumLightSpe = 0.0f;
	sumLightSpe += lightSpecular * refSpecularPow;

	// fɔˌ蓖Ă
	float4 diffuseCol = modelCol * sumLightCol;
	// ˂ɂ閾邳
	float4 specularCol = sumLightSpe * mateSpecularCol;

	// Fɔ˂̉e^ďo
	PS_OUT pixelOut;
	pixelOut.color = diffuseCol;
	pixelOut.color.rgb += specularCol.rgb;
	return pixelOut;
}

technique techReflection
{
	pass p0
	{
		VertexShader = compile vs_3_0 VS();
		PixelShader = compile ps_3_0 PS();
	}
}